<?php
error_reporting(E_ALL);
ini_set('display_errors', '1');

include_once("php_serial_class.php");
$device = "/dev/ttyACM0";

function sendCommand($device, $command) {

	$serial = new phpSerial;
	$serial->deviceSet($device); 
	$serial->confBaudRate(9600);
	$serial->deviceOpen(); 
	sleep(1);
	$serial->sendMessage($command."\r"); 
	$serial->deviceClose();


}

function createJSON($device) {

	$temperature = "";
	$humidity = "";
	$debug = "";

	$serial = new phpSerial;
	
	$serial->deviceSet($device); 
	$serial->confBaudRate(9600);

	$serial->deviceOpen(); 
	// sleep(1); // not needed if Arduino does not auto-reset on open
	$serial->sendMessage("31"); 

	$read = '';
	$theResult = '';
	$start = microtime(true);

	while ( ($read == '') && (microtime(true) <= $start + 1.0) ) {
		$read = $serial->readPort();
        if ($read != '') {
			$theResult .= $read;
			$read = '';
        }
		// check to see if we have got what we need
		if (	strpos($theResult, ",") > 0 && 
				strpos($theResult, "}") > 0 && 
				strpos($theResult, "{") >= 0 && 
				strpos($theResult, "}") > strpos($theResult, "{") ) 
			break;
		// $theResult = substr($theResult,0,13);	
	}

	// $serial->sendMessage("30"); // No longer needed!
	$serial->deviceClose(); 
	
	if (	strpos($theResult, ",") > 0 && 
			strpos($theResult, "}") > 0 && 
			strpos($theResult, "{") >= 0 && 
			strpos($theResult, "}") > strpos($theResult, "{") ) {
		$data = explode("{",$theResult);
		$theResult = $data[1];
		$data = explode("}",$theResult);
		$theResult = $data[0];		
		$data = explode(",",$theResult);
		$temperature = $data[1];
		$humidity = $data[0];
	} else {
		$debug = "Invalid data received! ".$theResult;
	}
	// echo "temperature = ".$temperature."C<br />";
	// echo "humidity = ".$humidity."%<br />";
	
	$html = file_get_contents("json.html");
	$html = str_replace("%Temperature%", $temperature, $html);
	$html = str_replace("%Humidity%", $humidity, $html);
	$html = str_replace("%Debug%", $debug, $html);	
	
	echo $html;
	
	return "";
}



if (isset($_GET["json"])) {
	$error = createJSON($device);
} elseif (isset($_GET["d"])){
	if($_GET["d"] == 0)
		sendCommand($device, "00");
	else
		sendCommand($device, "01");
	echo "DEBUG state toggled";
} elseif (isset($_GET["lcd"])){
	if($_GET["lcd"] == 0)
		sendCommand($device, "10");
	else
		sendCommand($device, "11");
	echo "LCD state toggled";
} elseif (isset($_GET["m"])){
	sendCommand($device, "20,".$_GET["m"]);
	echo "Message sent to LCD";
} elseif (isset($_GET["A"])){
	if($_GET["A"] == 1)
		sendCommand($device, "41");
	else
		sendCommand($device, "40");
	echo "ELRO Socket A state toggled";
} elseif (isset($_GET["B"])){
	if($_GET["B"] == 1)
		sendCommand($device, "51");
	else
		sendCommand($device, "50");
	echo "ELRO Socket B state toggled";
} elseif (isset($_GET["C"])){
	if($_GET["C"] == 1)
		sendCommand($device, "61");
	else
		sendCommand($device, "60");
	echo "ELRO Socket C state toggled";
} elseif (isset($_GET["D"])){
	if($_GET["D"] == 1)
		sendCommand($device, "71");
	else
		sendCommand($device, "70");
	echo "ELRO Socket D state toggled";	
} else {
	$html = file_get_contents("temp.html");
	echo $html;
}







?>